/*************************************************************************************
*
*    
*   
*
*  ANSI C, MISRA-C 2004
*
*  by:      BSVi
*  version: 1.2
*
*************************************************************************************/

#ifndef _BSVI_INCLUDE_
#define _BSVI_INCLUDE_

/*----------------------------------------------------------------------------------*/
/*                                                                         */
/*----------------------------------------------------------------------------------*/

/*  */
//#define AVR

/*----------------------------------------------------------------------------------*/
/*                                                                     */
/*----------------------------------------------------------------------------------*/
#ifdef AVR
//   #include <intrinsics.h>
//   #include <ioavr.h>
#endif /* AVR */


/*----------------------------------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------------------------------*/

typedef unsigned char	      uint8;
typedef unsigned short        uint16;
typedef unsigned long         uint32;
/* typedef unsigned long long    uint64; */  /*    ANSI-C,    */

typedef signed char	      int8;
typedef signed short	      int16;
typedef signed long	      int32;
/* typedef signed long long      int64; */   /*    ANSI-C,    */

typedef unsigned int          uint;

/*----------------------------------------------------------------------------------*/
/*                                                                   */
/*----------------------------------------------------------------------------------*/

#define uint32_MAXMAX 0xffffffffUL
#define uint16_MAXMAX 0xffff
#define uint8_MAXMAX  0xff

/*   */
typedef enum
{
   S_OK = 0,
   E_ERR = 1,
   E_USER = 2,
   E_NOSPACE = 3,
   E_IO = 4,
   E_COMM = 5
} Result;


/*----------------------------------------------------------------------------------*/
/*                                                                   */
/*----------------------------------------------------------------------------------*/

// #define MIN(n,m) (((n) < (m)) ? (n) : (m))
// #define MAX(n,m) (((n) < (m)) ? (m) : (n))
// #define ABS(n) (((n) < 0) ? -(n) : (n))

#define HIBYTE(a) (*((uint8*)&(a) + 1))
#define LOBYTE(a) (*((uint8*)&(a)))
#define HIWORD(a) (*((uint16*)&(a) + 1))
#define LOWORD(a) (*((uint16*)&(a)))

#define BYTE0(a) (*((uint8*)&(a) + 0))
#define BYTE1(a) (*((uint8*)&(a) + 1))
#define BYTE2(a) (*((uint8*)&(a) + 2))
#define BYTE3(a) (*((uint8*)&(a) + 3))
#define ARRAY_SIZE(a) ( sizeof(a)/sizeof(*(a)) )


/*----------------------------------------------------------------------------------*/
/*                                                                              */
/*----------------------------------------------------------------------------------*/

#ifndef BIT0
#define BIT0                (1<<0)
#define BIT1                (1<<1)
#define BIT2                (1<<2)
#define BIT3                (1<<3)
#define BIT4                (1<<4)
#define BIT5                (1<<5)
#define BIT6                (1<<6)
#define BIT7                (1<<7)
#define BIT8                (1<<8)
#define BIT9                (1<<9)
#define BIT10               (1<<10)
#define BIT11               (1<<11)
#define BIT12               (1<<12)
#define BIT13               (1<<13)
#define BIT14               (1<<14)
#define BIT15               (1<<15)
#define BIT16               (1UL<<16)
#define BIT17               (1UL<<17)
#define BIT18               (1UL<<18)
#define BIT19               (1UL<<19)
#define BIT20               (1UL<<20)
#define BIT21               (1UL<<21)
#define BIT22               (1UL<<22)
#define BIT23               (1UL<<23)
#define BIT24               (1UL<<24)
#define BIT25               (1UL<<25)
#define BIT26               (1UL<<26)
#define BIT27               (1UL<<27)
#define BIT28               (1UL<<28)
#define BIT29               (1UL<<29)
#define BIT30               (1UL<<30)
#define BIT31               (1UL<<31)
#endif


#endif	/* _BSVI_INCLUDE_ */
